(* $Id: oformat.mli,v 1.4 1998/12/14 11:30:36 garrigue Exp $ *)

class c : Format.formatter -> object
  val fm : Format.formatter
  method formatter : Format.formatter
  method open_hbox : unit
  method open_vbox : int -> unit
  method open_hvbox : int -> unit
  method open_hovbox : int -> unit
  method open_box : int -> unit
  method close_box : unit
  method string : string -> ?len:int -> unit
  method int : int -> unit
  method float : float -> unit
  method char : char -> unit
  method bool : bool -> unit
  method break : spaces:int -> offset:int -> unit
  method cut : unit
  method space : unit
  method force_newline : unit
  method flush : unit
  method newline : unit
  method if_newline : unit
  method open_tbox : unit
  method close_tbox : unit
  method tbreak : spaces:int -> offset:int -> unit
  method set_tab : unit
  method tab : unit
  method set_margin : int -> unit
  method get_margin : int
  method set_max_indent : int -> unit
  method get_max_indent : int
  method set_max_boxes : int -> unit
  method get_max_boxes : int
  method set_ellipsis_text : string -> unit
  method get_ellipsis_text : string
  method set_formatter_out_channel : out_channel -> unit
  method set_formatter_output_functions :
    out:(buffer:string -> pos:int -> len:int -> unit) ->
    flush:(unit -> unit) -> unit
  method get_formatter_output_functions :
    (buffer:string -> pos:int -> len:int -> unit) * (unit -> unit)
end

val create :
  out:(buffer:string -> pos:int -> len:int -> unit) ->
  flush:(unit -> unit) -> c

val of_channel : out_channel -> c
val std : c
