(* $Id: ohashtbl.mli,v 1.9 1999/04/30 07:53:41 garrigue Exp $ *)

class ['a, 'b] c :
    size:int -> ?eq:('a -> 'a -> bool) -> ?hash:('a -> int) ->
object
      (* [new c :size :eq :hash] creates a new hash table
	 of given initial size, hash function, and using equality
	 [eq] on keys.
	 [eq] and [hash] default to Pervasives.(=) (logical equality)
	 and Hashtbl.hash. [hash] shall be such that two keys equal
	 by [eq] have the same image by [hash] *)
  method clear : unit
  method add : key:'a -> data:'b -> unit
  method find : key:'a -> 'b
  method find_all : key:'a -> 'b list
  method remove : key:'a -> unit
  method mem : key:'a -> bool
  method iter : fun:(key:'a -> data:'b -> unit) -> unit
end
