(* $Id: omap.mli,v 1.11 1999/04/30 07:53:41 garrigue Exp $ *)

class ['a, 'b] c : ('a * 'b) list -> ?compare:('a -> 'a -> int) -> object
      (* [new c bindings :compare] creates a new map using
      	 compare as comparison function, and initializes it
	 with the given bindings.
	 [new c bindings] uses Pervasives.compare.
	 This map is imperative, and behaves exactly like
	 Hashtbl.c, except that previous old bindings for the
      	 same key are not kept *)
  method clear : unit
  method add : key:'a -> data:'b -> unit
  method find : key:'a -> 'b
  method mem : key:'a -> bool
  method remove : key:'a -> unit
  method iter : fun:(key:'a -> data:'b -> unit) -> unit
end

class ['a, 'b] f : ('a * 'b) list -> ?compare:('a -> 'a -> int) ->
object ('c)
      (* functional version of Omap.c *)
  method add : key:'a -> data:'b -> 'c
  method find : key:'a -> 'b
  method mem : key:'a -> bool
  method remove : key:'a -> 'c
  method iter : fun:(key:'a -> data:'b -> unit) -> unit
  method fold : fun:(key:'a -> data:'b -> acc:'d -> 'd) -> acc:'d -> 'd
end
