(* $Id: omapping.ml,v 1.3 1998/09/01 09:31:33 garrigue Exp $ *)

class virtual ['a,'b] c = object
  method virtual find : key:'a -> 'b
  method virtual iter : fun:(key:'a -> data:'b -> unit) -> unit
end

class virtual ['a,'b] f = object
  method virtual find : key:'a -> 'b
  method virtual iter : fun:(key:'a -> data:'b -> unit) -> unit
  method virtual fold :
      'c. fun:(key:'a -> data:'b -> acc:'c -> 'c) -> acc:'c -> 'c
end

class ['a,'b] alist l ?:eq = object
  inherit ['a,'b] f
  val assoc =
    match eq with
      Some (`physical : [physical logical]) -> List.assq
    | _ -> List.assoc
  val l = l
  method find :key = assoc key in:l
  method iter fun:f =
    List.iter l fun:(fun (key,data) -> f :key :data)
  method fold fun:f =
    List.fold_right l fun:(fun (key,data) -> f :key :data)
end
