(* Various indexes
    canvas
    entry
    listbox
*)


(* A large type for all indices in all widgets *)
(* a bit overkill though *)

(*
(* type *)
type index = [
	  Num(int)		(* no keyword  *)
          Active                (* tk keyword: active *)
	  End		        (* tk keyword: end *)
          Last			(* tk keyword: last *)
	  None		        (* tk keyword: none *)
	  Insert		(* tk keyword: insert *)
	  Selfirst		(* tk keyword: sel.first *)
	  Sellast		(* tk keyword: sel.last *)
          At int		(* tk keyword: @n *)
          Atxy(int * int)       (* tk keyword: @x,y *)
          Anchor   	        (* tk keyword: anchor *)
          Pattern string        (* no keyword *)
          Linechar (int * int)  (* tk keyword: l.c *)
          Mark (string)         (* no keyword *)
          Tagfirst (string)     (* tk keyword: tag.first *)
          Taglast (string)      (* tk keyword: tag.last *)
          Window (any widget)   (* no keyword *)
	  Image (string)        (* no keyword *)
]
(* /type *)
*)

type canvas_index = [
  Num(int)		
  End		        
  Insert		
  Selfirst		
  Sellast		
  Atxy(int * int)         
]

type entry_index = [
  Num(int)		
  End		        
  Insert		
  Selfirst		
  Sellast		
  At(int)		  
  Anchor   	
]

type listbox_index = [
  Num(int)		
  Active              
  Anchor   	
  End		        
  Atxy(int * int)
]

type menu_index = [
  Num(int)		
  Active              
  End		        
  Last			
  None		
  At(int)		  
  Pattern(string)       
]

type text_index = [
  Linechar(int * int)   
  Atxy(int * int)         
  End		        
  Mark(string)          
  Tagfirst(string)      
  Taglast(string)       
  Window(any widget)
  Image(string) 
]

type linechar_index = int * int
type num_index = int

let char_index c in:s =
  let rec find i =
    if i >= String.length s 
    then raise Not_found
    else if String.get s i = c then i 
    else find (i+1) in
  find 0

